PRINT " "
PRINT "PRODUCES OUTPUT (STORED IN 'MODEL.DAT') OF PARALLEL CASCADE MODEL."
PRINT "STORES ACTUAL OUTPUT IN 'REAL.DAT', RESIDUE IN 'RES.DAT', AND"
PRINT "INPUT/RESIDUE IN 'RESIDUE2.DAT'."
PRINT "PROGRAM REQUIRES 'PARALIN.DAT' CONTAINING LINEAR SYSTEMS OF THE"
PRINT "CASCADES, & 'PARAPOLY.DAT' CONTAINING THE STATIC NONLINEARITIES."
PRINT " "
PRINT "PROGRAM ALSO REQUIRES THE INPUT OUTPUT DATA FILE FOR THE NONLINEAR"
PRINT "SYSTEM BEING APPROXIMATED BY THE PARALLEL CASCADE."
INPUT "NAME OF INPUT OUTPUT DATA FILE";A$
PRINT " "
DEFDBL A,C,D,H,P,S,X,Y,Z
DEFINT N,R,I,J
INPUT "NUMBER OF CASCADES";NUM
INPUT "MEMORY LENGTH OF EACH LINEAR SYSTEM IN A CASCADE";R:RR=R-1
INPUT "DEGREE OF (POLYNOMIAL) STATIC NONLINEARITY";ND
OPEN A$ FOR INPUT AS #1
J=0
10 INPUT #1,A,B
J=J+1
IF EOF(1) THEN GOTO 20
GOTO 10
20 CLOSE #1
PRINT J;"INPUT OUTPUT DATA PAIRS READ."
INPUT "NUMBER OF INPUT DATA POINTS TO BE USED";T1
IF T1 > J THEN T1=J
T1=T1-1
INPUT "STARTING POINT FOR COMPUTING MEAN-SQUARE ERROR";RRR:RRR=RRR-1
DIM H(RR),CC(ND),X(T1),Y(T1),Z(T1)
OPEN "PARALIN.DAT" FOR INPUT AS #1
OPEN "PARAPOLY.DAT" FOR INPUT AS #2
OPEN A$ FOR INPUT AS #3
FOR N=0 TO T1
INPUT #3,X(N),Y(N)
NEXT N
CLOSE #3
'COMPUTE OUTPUT OF EACH CASCADE
FOR I=1 TO NUM
FOR J=0 TO RR
INPUT #1,II,JJ,H(JJ)
IF I <> II THEN PRINT "ERROR IN READING 'PARALIN.DAT'"
NEXT J
FOR J=0 TO ND
INPUT #2,IN,JJ,CC(JJ)
IF I <> IN THEN PRINT "ERROR IN READING 'PARAPOLY.DAT' I=";I;" IN=";IN:GOTO 100
NEXT J
FOR N=RR TO T1:D=0
FOR R1=0 TO RR
D=D+H(R1)*X(N-R1)
NEXT R1
E=0
FOR J=0 TO ND
E=E+CC(J)*D^J
NEXT J
Z(N)=Z(N)+E
NEXT N
NEXT I
CLOSE #2:CLOSE #1
AY=0:SY=0:DIF=0
RRRP1=RRR+1
FOR N=RRRP1 TO T1
AY=AY+Y(N):SY=SY+Y(N)*Y(N)
DIF=DIF+(Z(N)-Y(N))*(Z(N)-Y(N))
DIFXY=DIFXY+(X(N)-Y(N))*(X(N)-Y(N))
NEXT N
T1MR=T1-RRR
AY=AY/T1MR:SY=SY/T1MR:DIF=DIF/T1MR:DIFXY=DIFXY/T1MR
PMSE=100*DIF/(SY-AY*AY):PXY=100*DIFXY/(SY-AY*AY)
OPEN "MODEL.DAT" FOR OUTPUT AS #1
FOR N=0 TO T1
IF N > RRR THEN PRINT #1,N,Z(N)
NEXT N
CLOSE #1
OPEN "REAL.DAT" FOR OUTPUT AS #1
OPEN "RES.DAT" FOR OUTPUT AS #2
FOR N=0 TO T1
IF N > RRR THEN PRINT #1,N,Y(N):PRINT #2,N,Y(N)-Z(N)
NEXT N
CLOSE #2:CLOSE #1
OPEN "RESIDUE2.DAT" FOR OUTPUT AS #1
FOR N=0 TO T1
IF N > RRR THEN PRINT #1,X(N),Y(N)-Z(N)
NEXT N
CLOSE #1
PRINT "% MSE BETWEEN NONLINEAR SYSTEM & PARALLEL CASCADE = ";PMSE
PRINT "% MSE BETWEEN NONLINEAR SYSTEM OUTPUT & INPUT = ";PXY
PRINT "FIN"
100 END

